<?xml version="1.0" encoding="iso-8859-1"?>
<xsl:stylesheet version="1.0"
    xmlns:xsl="http://www.w3.org/1999/XSL/Transform">
  <xsl:output method="text" encoding="iso-8859-1"/>
  <xsl:template match="alf">//common.h: head file for share data for both host node and accelerator nodes
#ifndef __common_h__
#define __common_h__

#include &lt;alf_def.h&gt;
#include &lt;alf_config.h&gt;

<xsl:if test = "number(//BUFFER_NUMBER) > 0">
#define WZ_ARRAY_NUM <xsl:value-of select="number(//BUFFER_NUMBER)" />
</xsl:if>
<xsl:if test = "number(//PARTITION_METHOD) = 1">
#define ACCELERATOR_PARTITION
</xsl:if>
<xsl:if test = "number(//PARTITION_METHOD) =0">
//#define ACCELERATOR_PARTITION
</xsl:if><xsl:if test = "number(//BUFFER_NUMBER) > 0">
typedef struct _my_param_t
{
    struct _alf_my_param_t
    {
#ifdef  ACCELERATOR_PARTITION
        alf_data_addr64_t ea[WZ_ARRAY_NUM];
#endif
        unsigned int size[WZ_ARRAY_NUM];
        unsigned int buffer_offset[WZ_ARRAY_NUM];
       //TODO: Write down your parameters here
    }c;
    unsigned char _pad[(sizeof(struct _alf_my_param_t) + 15) &amp; 0xFF10];
} my_param_t;
<xsl:for-each select="buffer"><xsl:if test = "ELEMENT_TYPE[normalize-space(text()) != 'char'][normalize-space(text()) != 'unsigned char']
							  [normalize-space(text()) != 'signed char'][normalize-space(text()) != 'short']
							  [normalize-space(text()) != 'unsigned short'][normalize-space(text()) != 'int']
							  [normalize-space(text()) != 'unsigned int'][normalize-space(text()) != 'long']
							  [normalize-space(text()) != 'signed'][normalize-space(text()) != 'unsigned']
							  [normalize-space(text()) != 'unsigned long'][normalize-space(text()) != 'long long']
							  [normalize-space(text()) != 'unsigned long long'][normalize-space(text()) != 'float']
							  [normalize-space(text()) != '_Bool'][normalize-space(text()) != 'float _Complex']
							  [normalize-space(text()) != 'double _Complex'][normalize-space(text()) != 'long double _Complex']
							  [normalize-space(text()) != 'double'][normalize-space(text()) != 'long double']">
typedef struct _<xsl:value-of select="ELEMENT_TYPE"/>_t
{
    //TODO: Code your data structure here, make sure the size(Byte) of this
    //      structure is 1, 2, 4, 8 or power of 16.
    char pad[16];
}<xsl:value-of select="ELEMENT_TYPE"/>;
</xsl:if>
</xsl:for-each>
</xsl:if><!--if test = "number(//BUFFER_NUMBER) > 0"-->
<xsl:if test = "number(//BUFFER_NUMBER) = 0">
typedef struct _my_param_t
{
    struct _alf_my_param_t
    {
        char msg[16];
        //TODO: Write down your parameters here
    }c;
    unsigned char _pad[(sizeof(struct _alf_my_param_t) + 15) &amp; 0xFF10];
} my_param_t;
</xsl:if>

#endif //__COMMON_H__
</xsl:template>

</xsl:stylesheet>
